# std::basic_string::end, std::basic_string::cend

From cppreference.com
< cpp‎ | string‎ | basic string

iterator end(); |  |
const_iterator end() const; |  |
const_iterator cend() const; |  | (since C++11)

Returns an iterator to the character following the last character of the string. This character acts as a placeholder, attempting to access it results in undefined behavior.

### Parameters

(none)

### Return value

iterator to the character following the last character

### Exceptions

(none) | (until C++11)
`noexcept` specification: noexcept | (since C++11)

### Complexity

Constant

### Example

Run this code

    #include <iostream>
    #include <algorithm>
    #include <iterator>
    #include <string>

    int main()
    {
        std::string s("Exemparl");
        std::next_permutation(s.begin(), s.end());

        std::string c;
        std::copy(s.cbegin(), s.cend(), std::back_inserter(c));
        std::cout << c <<'\n'; // "Exemplar"
    }

Output:

    Exemplar

### See also

begin cbegin (C++11) | returns an iterator to the beginning (public member function)

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/string/basic_string/end&oldid=91678"
Category:

- unconditionally noexcept

Hidden categories:

- Pages with unreviewed unconditional noexcept template
- Pages with unreviewed noexcept template